Chino.io :: Scriba Documentation: the Application Programming Interface

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage

Install the generated package (see on top here or):

    pip install chinoscriba

## Getting Started

```python
import chinoscriba
from chinoscriba.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: Basic
configuration = chinoscriba.Configuration()
configuration.username = 'customer_id'
configuration.password = 'customer_key'

# create an instance of the API classes
logs_api = chinoscriba.LogsApi(chinoscriba.ApiClient(configuration))
stats_api = chinoscriba.StatsApi(chinoscriba.ApiClient(configuration))
blocks_api = chinoscriba.BlocksApi(chinoscriba.ApiClient(configuration))

limit = 56 # int | Number of results to return per page
offset = 0 # int | The initial index from which to return the results


# # Audit logs # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

# Create a new Log
body = chinoscriba.AuditLog() # AuditLog | 
try:
    api_response = logs_api.logs_create(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->logs_create: %s\n" % e)


# Create multiple Logs (bulk)
body = [chinoscriba.AuditLog()] # list[AuditLog] | 
try:
    api_response = logs_api.logs_multiple(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->logs_multiple: %s\n" % e)

try:
    # List all Logs
    api_response = logs_api.logs_list(limit=limit, offset=offset)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->logs_list: %s\n" % e)

try:
    # Search by query
    api_response = logs_api.logs_search(body, limit=limit, offset=offset)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->logs_search: %s\n" % e)

# # Stats # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
    
try:
    # Retrieve customer statistics
    api_response = stats_api.stats_read()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->stats_read: %s\n" % e)


# # Exporter # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

try:
    # List exportable Blocks
    api_response = blocks_api.exported_list(limit=limit, offset=offset)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->exported_list: %s\n" % e)


# Export a Block
block_id = "" # string | ID of the Block to download
try:
    # NOTE: due to an issue in a third-party library, this only works with 
    #  '_preload_content' disabled. This will bypass the malfunctioning code
    #  and return directly the HTTPResponse, which contains the zip file bytes
    #  in the 'data' attribute.
    res = blocks_api.exported_read(block_id, _preload_content=False)
    zip_bytes = res.data  # You can read this using python library 'zipfile'.
except ApiException as e:
    print("Exception when calling BlocksApi->exported_read: %s\n" % e)

```

## Changelog

### [next] - unreleased
- fixed events' tests

### [2.0.0] - 2021-01-22
- CHANGELOG.md (this file)
- added support for new events endpoints
- removed unique class `DefaultApi` in favour of specific classes based on
  endpoint semantic groups: `LogApi`, `BlockApi`, `EventsApi`, `StatsApi`

### [1.0.1] - 2021-01-15
- `DefaultApi` class which manages logs (create, list, search) and block
   downloads
